----------------------------------------------------------
-- File:          max_32bit.vhd 
-- Description:   Max values of the input
-- Designer:      Christos Zamantzas
-- Date:          03/12/2004 rev.3
----------------------------------------------------------

LIBRARY ieee;
USE ieee.std_logic_1164.all; 

LIBRARY work;

ENTITY Max_32bit IS 
   port
   (
      clk :  IN  STD_LOGIC;
      reset :  IN  STD_LOGIC;
      enable :  IN  STD_LOGIC;
      data :  IN  STD_LOGIC_VECTOR(31 downto 0);
      max :  OUT  STD_LOGIC_VECTOR(31 downto 0)
   );
END Max_32bit;

ARCHITECTURE Structure OF Max_32bit IS 

component max_compare_32bit
   PORT(dataa : IN STD_LOGIC_VECTOR(31 downto 0);
       datab : IN STD_LOGIC_VECTOR(31 downto 0);
       agb : OUT STD_LOGIC
   );
end component;

signal   en_max :  STD_LOGIC;
signal   greater :  STD_LOGIC;
signal   max_int :  STD_LOGIC_VECTOR(31 downto 0);

BEGIN 

instmax32 : max_compare_32bit
PORT MAP(dataa => data,
       datab => max_int,
       agb => greater);


process(clk,reset)
begin
if (reset = '1') then
   max_int <= (others => '0'); 

elsif (rising_edge(clk)) then
   if (en_max = '1') then
   max_int <= data;
   end if;
end if;
end process;

en_max <= greater AND enable;


max <= max_int;

END; 