-- OneShot output circuit.
-- this block clears and registers the Input.

-- Designer: Cristos Zamantzas
-- Version: 5
-- Date: 03/04/2006

LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.all;
USE IEEE.STD_LOGIC_UNSIGNED.all;

ENTITY OneShot IS
	
	PORT(Input, clk	: IN	STD_LOGIC;
		 OneShot 		: OUT	STD_LOGIC);

END OneShot;

ARCHITECTURE RTL OF OneShot IS
	SIGNAL Input_delay : STD_LOGIC;
	
BEGIN
 PROCESS (clk)
 BEGIN
    IF  rising_edge(clk) THEN
  		IF Input = '1' AND Input_delay = '0' THEN
   			OneShot <= '1';
  		ELSE
   			OneShot <= '0';
  		END IF;
		Input_delay <= Input;
    END IF;

 END PROCESS;

END RTL;
