LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.all;
USE IEEE.STD_LOGIC_ARITH.all;
USE IEEE.STD_LOGIC_UNSIGNED.all;

-- Autotrigger circuit
	-- the trigger will go high (and remain) until SRAM_Filled becomes high.
	-- second trigger will not be allowed unless PM_Allowed becomes high.

ENTITY AutoTrigger IS
	
	PORT(PM_Request, SRAM_Filled, PM_allowed, clk	: IN	STD_LOGIC;
		 PM_Trigger, PM_BlindTime		: OUT	STD_LOGIC);

END AutoTrigger;

ARCHITECTURE RTL OF AutoTrigger IS
	SIGNAL PM_Request_int : STD_LOGIC;
	SIGNAL PM_BlindTime_int : STD_LOGIC;

BEGIN
 PROCESS (clk)
 BEGIN
    IF  rising_edge(clk) THEN
  		IF PM_Request = '1' AND PM_Request_int = '0' AND PM_BlindTime_int = '0' THEN
   			PM_Request_int <= '1';
			PM_Trigger <= '1';
  		END IF;
		IF SRAM_Filled ='1' THEN
			PM_BlindTime_int <= '1';
			PM_Request_int <= '0';
			PM_Trigger <= '0';
		END IF;
		IF PM_Allowed = '1' THEN
			PM_BlindTime_int <= '0';
		END IF;		
	END IF;
    PM_blindTime <= PM_BlindTime_int;
 END PROCESS;

END RTL;
